"use strict";

// ------------------------------------------------------------------------
// Copyright (c) 2018-2024 Alexandre Bento Freire. All rights reserved.
// Licensed under the MIT License.
// ------------------------------------------------------------------------
Object.defineProperty(exports,"__esModule",{value:!0}),exports.OptsParser=void 0;var OptsParser,rel_consts_js_1=require("../shared/rel-consts.js");!function(e){function t(e){return e.replace(/([A-Z])/g,function(e,t){return"-"+t.toLowerCase()})}e.DEFAULT_OUT_PATTERN="__PROJDIR__/story-frames/frame%05d.png",e.DEFAULT_OUT_REPORT="__FRAMES_DIR__/frame-report.json",e.ON_ERROR_EXIT_VALUE=-1,e.DEFAULT_MAX_WIDTH=3840,e.DEFAULT_MAX_HEIGHT=2160,e.DEFAULT_MAX_FPS=50,e.DEFAULT_MAX_FRAME_COUNT=72e3,e.DEFAULT_PROGRESS=25,e.argOpts={ll:{param:"int",desc:"log level. 0 has no verbosity"},version:{desc:"version"},url:{param:"string",desc:"url of the page containing the animation\n              e.g. http://abeamer.devtoix.com/\n              e.g. file:///home/abeamer/Documents/test/"},file:{param:"string",desc:"for running local files with relative paths\n           if --out isn't defined it sets to ".concat(e.DEFAULT_OUT_PATTERN,"\n              e.g --file gallery/hello-world/")},out:{param:"string",desc:"output file pattern. use %(0<n>)d for sequence,\n           creates the destination folder if doesn't exists\n           if it's defined after --file, the macro  will be file value\n             e.g. --out ".concat(e.DEFAULT_OUT_PATTERN)},report:{param:"string",desc:"output report filename providing information about dimensions and fps\n           default is ".concat(e.DEFAULT_OUT_REPORT)},allowedPlugins:{param:"string",desc:"filename of the the list of the allowed plugins"},injectPage:{param:"string",desc:"filename of the index.html that will receive the injection"},width:{param:"int",desc:"frame output width. default is ".concat(rel_consts_js_1.RelConsts.DEFAULT_WIDTH)},maxWidth:{param:"int",desc:"maximum frame output width. default is ".concat(e.DEFAULT_MAX_WIDTH)},height:{param:"int",desc:"frame output height. default is ".concat(rel_consts_js_1.RelConsts.DEFAULT_HEIGHT)},maxHeight:{param:"int",desc:"maximum frame output height. default is ".concat(e.DEFAULT_MAX_HEIGHT)},scale:{param:"string",desc:"scales to gif or movie movie generators.\n          e.g.\n             --scale 25%\n             --scale 200,400\n             --scale 40%,30%\n          "},noframes:{desc:"doesn't render the frames to file nor generates the report.\n           use it only for debugging"},server:{param:"string",desc:"name of the server. default is ".concat(rel_consts_js_1.RelConsts.DEFAULT_SERVER)},serverExec:{param:"string",desc:"name of the server executable. default puppeteer=node. slimerjs=slimerjs"},fps:{param:"int",desc:"overrides frames per second defined on project"},maxFps:{param:"int",desc:"maximum frame per second. default is ".concat(e.DEFAULT_MAX_FPS)},maxFrameCount:{param:"int",desc:"maximum number of frames. default is ".concat(e.DEFAULT_MAX_FRAME_COUNT)},progress:{param:"int",desc:"number of frames it displays a progress info. if 0 doesn't shows progress. default is ".concat(e.DEFAULT_PROGRESS)},timeout:{param:"int",desc:"server timeout. default is 0"},teleport:{desc:"makes the web browser run on teleport mode, and generates the story on the exit"},dp:{desc:"deletes previous frames"},config:{param:"string",desc:"loads the config from a ini or json file\n           see https://abeamer.devtoix.com/docs/latest/end-user/en/site/config-file/"},var:{param:"object",desc:"allows to pass multiple variables to client web library.\n         accessible as story.args.vars or in expressions.\n         if the variable name has dashes, it will be converted to camelCase\n           e.g --var name=end-user --var value=1.2.3"}},e.isOption=function(e){return 0===e.indexOf("--")},e.iterateArgOpts=function(t,a,r){for(;;){var s=(a()||"").trim();if(!s)break;if(e.isOption(s)){var n=s.substr(2).replace(/-(\w)/g,function(e,t){return t.toUpperCase()}).replace(/__\d+$/,""),i=e.argOpts[n];if(void 0===i)throw"Unknown option ".concat(n);if(i.hasOption=!0,i.param){if(i.value=a(),!i.value||e.isOption(i.value)&&!i.allowOption)throw"Missing value for ".concat(s);if(t)switch(i.param){case"int":if(i.value.match(/[^\d]/))throw"".concat(s," ").concat(i.value," isn't a integer value");i.value=parseInt(i.value);break;case"boolean":i.value="true"===i.value||"1"===i.value;break;case"object":i.multipleValue=i.multipleValue||{};var o=i.value.match(/^([^=]+)=(.*)$/)||["","",""],l=o[1],c=o[2];if(!l)throw"".concat(s," requires the key field");i.multipleValue[l]=c;break;case"array":i.multipleValue=i.multipleValue||[],i.multipleValue.push(i.value)}}var u=r(n,i.value,i.multipleValue);if(void 0!==u)return u}else r("@param",s)}},e.computeScale=function(t,a){function r(e,t){var a=1;e.endsWith("%")&&(a=t/100,e=e.substr(0,e.length-1));var r=parseInt(e,10)*a;return Math.round(r).toString()}var s=(e.argOpts.scale.value||"").trim();if(s){var n=s.split(/\s*,\s*/);return[r(n[0],t),r(n[1]||n[0],a)]}},e.printUsage=function(){var a=Object.keys(e.argOpts),r=0;a.forEach(function(e){r=Math.max(t(e).length,r)});var s=r+3,n=5+s+2;console.log("\n The options are:\n "+a.map(function(a){var r=t(a);return"   --".concat(r).concat(Array(s-r.length).join(" "))+"".concat(e.argOpts[a].desc.split("\n").map(function(e,t){return Array(t?n:0).join(" ")+e.trim()}).join("\n"),"\n\n")}).join("\n"))}}(OptsParser||(exports.OptsParser=OptsParser={}));