"use strict";

// ------------------------------------------------------------------------
// Copyright (c) 2018-2024 Alexandre Bento Freire. All rights reserved.
// Licensed under the MIT License.
// ------------------------------------------------------------------------
var __extends=this&&this.__extends||function(){var e=function(t,r){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])})(t,r)};return function(t,r){if("function"!=typeof r&&null!==r)throw new TypeError("Class extends value "+String(r)+" is not a constructor or null");function n(){this.constructor=t}e(t,r),t.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}();Object.defineProperty(exports,"__esModule",{value:!0}),exports.HttpServerEx=void 0;var HttpServerEx,sysFs=require("fs"),http_server_js_1=require("./http-server.js");!function(e){var t=function(e){function t(t,r,n,o,i,s){void 0===r&&(r=!1),void 0===n&&(n=""),void 0===o&&(o=!1),void 0===i&&(i=!1),void 0===s&&(s=!1);var l=e.call(this,t)||this;return l.isVerbose=r,l.exitFile=n,l.allowDirListing=o,l.markdownCompiler=i?require("marked"):void 0,l.highlightJs=s?require("highlight.js"):void 0,l}return __extends(t,e),t.prototype.markdownToHtml=function(e){var t=this;return this.markdownCompiler.setOptions({renderer:new this.markdownCompiler.Renderer,highlight:function(e){return t.highlightJs?t.highlightJs.highlightAuto(e).value:e},pedantic:!1,gfm:!0,tables:!0,breaks:!1,sanitize:!1,smartLists:!0,smartypants:!1,xhtml:!1}),"<html>\n<head>\n"+(this.highlightJs?'\n    <link rel="stylesheet" href="/node_modules/highlight.js/styles/github.css">\n    <link rel="stylesheet" href="/node_modules/font-awesome/css/font-awesome.css">\n    <style>\n    body {\n      font-family: -apple-system,BlinkMacSystemFont,"Segoe UI",Helvetica,Arial,\n        sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol";\n        color: #24292e;\n        background-color: white;\n    }\n    pre {\n      background-color: #1b1f230d;\n      padding: 0.2em 0.4em;\n    }\n    #__page {\n       max-width: 980px;\n       padding: 45px;\n       border: 1px solid #ddd;\n       border-bottom-right-radius: 3px;\n       border-bottom-left-radius: 3px;\n       margin-left: 20px;\n    }\n    code {\n      background-color: #1b1f230d;\n      padding: 0.2em 0.4em;\n    }\n    pre code {\n      background-color: transparent;\n      padding: 0;\n    }\n\n    </style>\n    <script src="/node_modules/highlight.js/lib/highlight.js"><\/script>\n    <script>hljs.initHighlightingOnLoad();<\/script>\n':"")+"</head>\n<body>\n<div id=__page>"+this.markdownCompiler(e)+"</div></body>\n</html>"},t.prototype.onBeforeServe=function(e,t){return e.url.length>1024||-1!==e.url.indexOf("..")||e.url.match(/\.[\w+\-]+\.(json|txt|ini)$/)?(t.statusCode=403,t.end("forbidden url"),!1):(this.isVerbose&&console.log("".concat(e.method," ").concat(e.url)),!this.exitFile||-1===e.url.indexOf(this.exitFile)||(this.isVerbose&&console.log("Closing the server"),this.httpServer.close(),!1))},t.prototype.onAfterServe=function(e){if(this.markdownCompiler&&".md"===e.ext){var t=sysFs.readFileSync(e.path,{encoding:"utf-8"});return e.res.setHeader("Content-type","text/html"),e.res.end(this.markdownToHtml(t)),!1}return!0},t.prototype.handleDirectory=function(t){return this.allowDirListing&&"?dir"===t.search?(sysFs.readdir(t.path,function(e,r){var n=t.path+(t.path.endsWith("/")?"":"/"),o=r.map(function(e){var t="".concat(n).concat(e),r=t.substr(1);return{file:e,fileName:t,url:r,isDir:sysFs.statSync(t).isDirectory()}});o.sort(function(e,t){return e.isDir===t.isDir?e.file.localeCompare(t.file):e.isDir?-1:1}),"./"!==n&&o.unshift({file:"..",fileName:"".concat(n,".."),url:"".concat(n.substr(1),"../"),isDir:!0});var i='<html>\n<head>\n<style>\nbody {\n    font-family: -apple-system,BlinkMacSystemFont,"Segoe UI",Helvetica,Arial,\n      sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol";\n      color: #24292e;\n      background-color: white;\n}\n</style>\n          </head><body>\n'+o.map(function(e){var t=e.isDir,r=[];return t&&http_server_js_1.HttpServer.DEFAULT_FILES.forEach(function(t){var n="".concat(e.fileName,"/").concat(t);sysFs.existsSync(n)&&r.push('&nbsp;(<a href="'.concat(e.url,"/").concat(t,'">').concat(t,"</a>)"))}),t?'<div>[<a href="'.concat(e.url).concat("?dir",'">').concat(e.file,"</a>]").concat(r.join(""),"</div>"):'<div><a href="'.concat(e.url,'">').concat(e.file,"</a></div>")}).join("\n")+"\n</body>\n</html>";t.res.setHeader("Content-type","text/html"),t.res.end(i)}),!1):e.prototype.handleDirectory.call(this,t)},t}(http_server_js_1.HttpServer.Server);e.ServerEx=t}(HttpServerEx||(exports.HttpServerEx=HttpServerEx={}));